# Contributing

We welcome contributions, and request you follow these guidelines.

 - [Raising issues](#raising-issues)
 - [Contributor License Agreement](#contributor-license-agreement)
 - [Guidelines](#guidelines)

## Raising issues

Please raise any bug reports on the issue tracker. Be sure to
search the list to see if your issue has already been raised.

A good bug report is one that make it easy for us to understand what you were
trying to do and what went wrong. Provide as much context as possible so we can try to recreate the issue.

### Contributor License Agreement

In order for us to accept pull-requests, the contributor must first complete a Contributor License Agreement (CLA). This clarifies the intellectual property license granted with any contribution. It is for your protection as a Contributor as well as the protection of IBM and its customers; it does not change your rights to use your own Contributions for any other purpose.

Our CLA process is automated through a CLAassistant bot which comments on each Pull Request. Please click through the link in the comment to sign the CLA in your browser.

### Guidelines

Please ensure you follow these guidelines:

 - All files must have the Apache license in the header.
 - All PRs must have passing builds.
